#!/usr/local/ActivePerl-5.14/bin/perl -w
use feature 'unicode_strings';
use utf8;
use warnings;
use strict;
use Data::Dumper;
use File::Basename;

my %charmap = ();
my $charmap;
my ($charfile,$basedirname) = @ARGV;
my $tagLine;
my $tagSize;
my $tagrv;
my $tagHeader;
my $tagbuffer;
my $tagfile;

my $unitags = $basedirname . "-unicode_tags";
mkdir("$unitags");
my $uniDirName = $basedirname . "-unicode";




for (0...31) { 
#print "Hex:\t".sprintf("%x",$_)."\tMyth Number:$_"."\n"; 
print "Hex:\t".pack("H*",sprintf("%x",$_))."\tMyth Number:$_"."\tOrdi:".ord(pack("H*",sprintf("%x",$_)))."\n"; 

$charmap{ pack("H*",sprintf("%x",$_)) } = $_;
}


opendir(DIR, $uniDirName) or die "can't opendir $uniDirName: $!";
print 'The $basedirname is: ' . $basedirname . "\n";
print 'The $uniDirName is: ' . $uniDirName . "\n";


while (defined($tagfile = readdir(DIR))) {
next if $tagfile =~ /^\.\.?$/; # skip . and .. # ...
next if $tagfile =~ /DS_Store/;

my $name = $tagfile;
$name =~ s/.txt//g;

print "$basedirname-headers"."/"."$name.header" . "\n\n";
open TAGFILE, "$basedirname-headers"."/"."$name.header" or die("Couldn't open tagfile first time: $!");
binmode TAGFILE;
while (defined ($tagLine = <TAGFILE>)) {
    chomp $tagLine;
    $tagSize = length $tagLine;
}
print "The tag file size is:\t".$tagSize."\n";
open TAGFILE, "$basedirname-headers"."/"."$name.header" or die("Couldn't open tagfile second time: $!");
binmode TAGFILE;

#assign local tags first 64 bytes to $tagHeader
$tagrv = read(TAGFILE, $tagbuffer, 64) or die "Couldn't read from TAGFILE : $!\n";
$tagHeader = unpack("H*", $tagbuffer);


open NEWTAG, ">","$unitags" . "/" . "$name";
binmode NEWTAG;
print NEWTAG pack("H*",$tagHeader);



open CHARMAPFILE, "<:encoding(UTF16-LE)", "$charfile";

my $string = <CHARMAPFILE>;
#my @list = unpack( '(a)' x length($string), $string );
my @list = unpack( '(a)*', $string );

    my $i =32;
	foreach (@list) {
        my $char = $_;
        my $ordi = ord($char);
	$charmap{ $char } = $i;

       # print "Character:\t" . $char . "\tHex:\t".unpack('H*',$_)."\tOrdinal:\t" . $ordi . "\tArray:\t".$i."\n";
	$i++;
    }

open TRANSLATORTEXT, "<:encoding(UTF16-LE)", "$uniDirName"."/"."$tagfile" or die("Couldn't open TRANSLATORTEXT: $tagfile : $!\n");


while (<TRANSLATORTEXT>) {
    my $string = $_;

my @list = unpack( 'a' x length($string), $string );


	foreach (@list) {

        my $char = $_;
        my $ordi = ord($char);
        

	binmode STDOUT, ":utf8";
#	print "Testing $char\tCrazy:\t".hex(sprintf( '%2.2x', unpack( 'U0U*', $char )))."\n";
	if ($charmap{ $char }) {
#       print "Character:\t" . $char . "\t".unpack("H*", pack("N", $charmap{$char})). "\n";	
#       print "Character:\t" . $char . "\t".sprintf("%X", $charmap{$char}). "\n";	
#	print $charmap{$char} ."\n";
	print NEWTAG pack("H*",sprintf("%X", $charmap{$char}));

	} elsif (sprintf( '%2.2x', unpack( 'U0U*', $char )) eq "0a") {
#		print "Match 0a:".$char ."\n";

		print NEWTAG pack("H*",'0D');

	} elsif (hex(sprintf( '%2.2x', unpack( 'U0U*', $char ))) < 32) {
#		print "FOUND A LESS THAN 32!".hex(sprintf( '%2.2x', unpack( 'U0U*', $char )))."\n";
		if (sprintf( '%2.2x', unpack( 'U0U*', $char )) ne "0d") {
		print NEWTAG pack("H*",sprintf( '%2.2x', unpack( 'U0U*', $char )));
		}
	} else {
		print "Character '". sprintf( '%2.2x', unpack( 'U0U*', $char ))."' does not exist in charmap\n";
	}
   }


}

} #end massive while
